void drawOrbit()
{
  for (int i = 0; i < MovieName.values().length - 1; i++)
  {
    stroke(#FFFFFF, 70  );
    strokeWeight(0.1);
    noFill();
    float currentRadius = radius * 2 / MovieName.values().length * (findReleasedYear(MovieName.values()[i]) - 1991);
    // print("current radius", currentRadius);
    pushMatrix();
    translate(0, 0, -100);
    ellipse(0, 0, currentRadius, currentRadius);
    popMatrix();
  }
}

void drawLine(int index)
{
  stroke(#ffffff, 100);
  strokeWeight(2);
  // println("allLines size", allLines.size());
  for (int k = 0; k < allLines[index].size(); k++)
  {
    PVector p1, p2;
    p1 = allLines[index].get(k).p1;
    p2 = allLines[index].get(k).p2;
    // println(p1.x, p1.y, p1.z, p2.x, p2.y, p2.z);
    line(p1.x, p1.y, p1.z, p2.x, p2.y, p2.z);
  }
}

void drawMovies()
{
  for(int i = 0; i < movies; i++)
    drawSpiningMovie(i);
}

void drawSpiningMovie(int index)
{
  // {movieIndex, x, y, z, size, angle}
  float currentRadius = radius / MovieName.values().length * (findReleasedYear(findMovieName(index)) - 1991);
  float angle = startAngle[index] + frameCount * map(totalCheckoutsYearly[index], minCheckouts, maxCheckouts, 0, 0.005) % TWO_PI;
  float r = map(totalCheckoutsYearly[index], minCheckouts, maxCheckouts, 0, 100);
  pushMatrix();
  currCenter[index] = new PVector(currentRadius * cos(angle), currentRadius * sin(angle), -100 - r/8);
  translate(currentRadius * cos(angle), currentRadius * sin(angle), -100 - r/8);
  for (int i = 0; i < allPoints[index].size(); i++)
  {  
    // noFill();
    for (int j = 0; j < allPoints[index].get(i).length; j++)
    {
      DataPoint pts = allPoints[index].get(i)[j];
      strokeWeight(pts.size);
      // println("pts size", pts.size);
      stroke(elementDetermine(findMovieName(index)), 150);
      point(pts.x, pts.y, pts.z);
    }
  }
  // drawLine(index);
  strokeWeight(2);
  stroke(elementDetermine(findMovieName(index)), 50);
  //noStroke();
  fill(elementDetermine(findMovieName(index)), 50);
  //sphereDetail(12);
  //sphere(r);
  if (index != 6)
    wrap[index].plot(); 
  popMatrix();
}

void drawSingleMovie(int index)
{
  // {movieIndex, x, y, z, size, angle}
  //float currentRadius = radius / MovieName.values().length * (findReleasedYear(findMovieName(index)) - 1991);
  //float angle = startAngle[index] + frameCount * map(totalCheckoutsYearly[index], minCheckouts, maxCheckouts, 0, 0.005) % TWO_PI;
  //float r = map(totalCheckoutsYearly[index], minCheckouts, maxCheckouts, 0, 100);
  pushMatrix();
  translate(0, 0, 0);
  for (int i = 0; i < allPoints[index].size(); i++)
  {  
    // noFill();
    for (int j = 0; j < allPoints[index].get(i).length; j++)
    {
      DataPoint pts = allPoints[index].get(i)[j];
      strokeWeight(pts.size);
      // println("pts size", pts.size);
      stroke(elementDetermine(findMovieName(index)), 150);
      point(pts.x, pts.y, pts.z);
    }
  }
  strokeWeight(2);
  stroke(elementDetermine(findMovieName(index)), 50);
  //noStroke();
  fill(elementDetermine(findMovieName(index)), 50);
  if (index != 6)
    wrap[index].plot(); 
    
  drawCoordinateSys(index);
  popMatrix();
}


void drawCoordinateSys(int index)
{

  // draw years
  pushMatrix();
  noFill();
  rotateY(PI/2);
  stroke(180);
  strokeWeight(1);
  ellipse(0, 0, 200, 200);

  for (int i = 0; i < YEARS - 1; i++) {
    noFill();
    pushMatrix();
    float theta = (i+1)*PI/13;
    translate(100*cos(theta+PI/2), 100*sin(theta+PI/2));
    rotate(theta+PI/2+PI);
    textAlign(LEFT, CENTER);
    fill(180);
    textSize(10);
    text(i + 2006, 1, 0);
    popMatrix();
  }
  popMatrix();

  // draw item type
  pushMatrix();
  noFill();
  rotateX(PI/2);
  stroke(180);
  strokeWeight(1);
  ellipse(0, 0, 200, 200);

  for (int i = 0; i < allPoints[index].size(); i++) {
    pushMatrix();
    float theta = i * TWO_PI / allPoints[index].size();
    translate(100*cos(theta+PI/2), 100*sin(theta+PI/2));
    rotate(theta+PI/2+PI);
    textAlign(RIGHT, CENTER);
    fill(180);
    textSize(12);
    text(matchItemtype(checkouts[index].get(i).first), 0, 0);
    popMatrix();
  }
  popMatrix();
}

void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  drawNote();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

void drawNote()
{
  
  fill(255, 255, 255);
  textAlign(LEFT, CENTER);
  String s = "Quentin Tarantino's Films";
  textSize(TEXTSIZE * 2);
  text(s, marginToTop, marginToLeft);
  textSize(TEXTSIZE);
  String[] movieNames = {"Reservoir Dogs (1992)", "Pulp Fiction (1994)", "Jackie Brown (1997)", "Kill Bill: Volume 1 (2003)", "Kill Bill: Volume 2 (2004)", 
    "Death Proof (2007)", "Inglourious Basterds (2009)", "Django Unchained (2012)", "The Hateful Eight (2015)"};                   
  for (int j = 0; j < checkouts.length; j++)
  {
    text(movieNames[j], TEXTSIZE * movieNames.length / 2, HEIGHT - (10 - j) * TEXTSIZE);
    strokeWeight(10);
    stroke(elementDetermine(findMovieName(j)));
    point(TEXTSIZE * movieNames.length / 2.5, HEIGHT - (10 - j) * TEXTSIZE);
  }
}